/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demo.ejb.test.client;

import demo.ejb.test.GreeterFacadeRemote;
import java.util.Date;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 *
 * @author ojantz
 */
public class TestEAClient {

    private static Logger _logger = Logger.getLogger(TestEAClient.class.getCanonicalName());
    private static String RESPONSE_TIMEOUT_PROPERTY = "com.sun.corba.ee.transport.ORBWaitForResponseTimeout";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws NamingException {
        
        String appServerType = args[0];
        String host = args[1];
        String port = args[2];
        Properties properties = null;
        if(appServerType.toUpperCase().equals(AS.JBOSS.toString())) {
            properties = buildProperties(AS.JBOSS, host, port);
        } else if(appServerType.toUpperCase().equals(AS.GLASSFISH.toString())) {
            properties = buildProperties(AS.GLASSFISH, host, port);
        }
        
        if(properties == null) System.exit(1);
        
        while (true) {
            //Context ctx = null;
            try {
                
//                Callable<String> task = new Callable<String>() {
//
//                    @Override
//                    public String call() throws Exception {


                        _logger.log(Level.INFO, "Trying to get initial context with props: " + properties.toString());
                        Context ctx = new InitialContext(properties);
                        _logger.log(Level.INFO, "Got initial context.");
                        String facadeName = GreeterFacadeRemote.class.getCanonicalName();
                        _logger.log(Level.INFO, "Trying to lookup remote facade: " + facadeName);
                        //GreeterFacadeRemote facade = (GreeterFacadeRemote) ctx.lookup(facadeName);
                        
                        GreeterFacadeRemote facade = null;
                        if(AS.JBOSS.toString().toUpperCase().equals(appServerType)) {
                            facade = (GreeterFacadeRemote) ctx.lookup("GreeterFacade/remote-" + facadeName);    
                        } else if (AS.GLASSFISH.toString().toUpperCase().equals(appServerType)) {
                            facade = (GreeterFacadeRemote) ctx.lookup(facadeName);    
                        }
                        
                        if(facade == null) System.exit(1);
                        
                        _logger.log(Level.INFO, "Got facade instance: " + facade);
                        _logger.log(Level.INFO, "Calling method sayHelloTo(Client)");
                        String result = facade.sayHelloTo("Client");
                        System.out.println((new Date()) + ": " + result);
                        _logger.log(Level.INFO, "Called successfully.");
                        
//                        return result;
//                    }
//                };
//
//                ExecutorService executor = Executors.newSingleThreadExecutor();
//                String result = executor.submit(task).get(30, TimeUnit.SECONDS);
//                executor.shutdown();

             
                
            } catch (Throwable ex) {

                boolean isTimeout = true;
//                Throwable inner = ex;
//                while(inner.getCause() != null) {
//                    inner = inner.getCause();
//                    if(inner instanceof org.omg.CORBA.COMM_FAILURE && inner.getMessage().toLowerCase().contains("waiting for response")) {
//                        isTimeout = true;
//                    }
//                }
                
                _logger.log(Level.SEVERE, ex.getMessage(), ex);
                ex.printStackTrace();

                if (isTimeout) {
                    _logger.log(Level.INFO, "Resuming after exception.");
                    continue;
                } else {
                    break;
                }

            } finally {
                Runtime.getRuntime().gc();
            }
            sleep(20);
        }
    }
    
    private static enum AS {
        JBOSS,
        GLASSFISH
    }
    
    private static Properties buildProperties(TestEAClient.AS appServerType, String host, String port) {
        Properties properties = new Properties();
        switch(appServerType) {
            case JBOSS:
                properties.put("java.naming.provider.url", "jnp://" + host + ":" + port);
                properties.put("java.naming.factory.initial", "org.jnp.interfaces.NamingContextFactory");
                properties.put("java.naming.factory.url.pkgs", "org.jboss.naming:org.jnp.interfaces");
                properties.put("jnp.socket.Factory", "org.jnp.interfaces.TimedSocketFactory");
                break;
            case GLASSFISH:
                properties.setProperty("org.omg.CORBA.ORBInitialHost", host);
                properties.setProperty("org.omg.CORBA.ORBInitialPort", port);
                properties.setProperty("java.naming.factory.state", "com.sun.corba.ee.impl.presentation.rmi.JNDIStateFactoryImpl");
                properties.put("java.naming.factory.initial", "com.sun.enterprise.naming.SerialInitContextFactory");
                break;
        }
        return properties;
            
    }
            

    private static void sleep(int sec) {
        _logger.log(Level.INFO, "Waiting for " + sec + " seconds.");
        int i = 0;
        while (i < sec) {
            try {
                Thread.sleep(1000);
                System.out.print(".");
            } catch (InterruptedException ex) {
                Logger.getLogger(TestEAClient.class.getName()).log(Level.SEVERE, null, ex);
            }
            i++;
        }
    }
    
 
}
